var facebookAPI=function(){
			return{
			
				currentAuthToken:'',
				receivedDataCallback:'',
				debugMode:1,
				me:{},
			
			
				init:function(){

					/************************************
						Make sure we have access to the intel.xdk library
					************************************/
					try{
						intel.xdk.device;
						return true;
					}catch(er){
						alert('You are missing the intel.xdk library. Please include the intel.xdk library to support Push Messages.');
						return false;
					}

				},
				
				login:function(callbackFunction){
					facebookAPI.debug("about to log into facebook");
					if(callbackFunction!='' && callbackFunction!=undefined && callbackFunction!='undefined' && callbackFunction!=null){
						facebookAPI.receivedDataCallback=callbackFunction;
						document.addEventListener("intel.xdk.facebook.login",function(e){
							facebookAPI.currentAuthToken = e.token;
							try { this.getUser(); } catch(e) {}
						
							//make the callback
							eval(facebookAPI.receivedDataCallback(e));
						},false); 
					}
					intel.xdk.facebook.login("email,publish_stream,publish_actions,offline_access");
				},
				
				//name,picture,caption,description,link are all possible parameters
				post:function(params,callbackFunction) {
					try { document.removeEventListener("intel.xdk.facebook.dialog.complete"); } catch(e) {}
					if(callbackFunction!='' && callbackFunction!=undefined && callbackFunction!='undefined' && callbackFunction!=null){
						facebookAPI.receivedDataCallback=callbackFunction;
						document.addEventListener("intel.xdk.facebook.dialog.complete",facebookAPI.receivedDataCallback,false); 
					}
					intel.xdk.facebook.showNewsFeedDialog(params);				
				},
				
				//message, title, filters, exclude_ids, max_recipients, data are all possible parameters
				request:function(params, callbackFunction) {
				
					try { document.removeEventListener("intel.xdk.facebook.dialog.complete"); } catch(e) {}
					if(callbackFunction!='' && callbackFunction!=undefined && callbackFunction!='undefined' && callbackFunction!=null){
						facebookAPI.receivedDataCallback=callbackFunction;
						document.addEventListener("intel.xdk.facebook.dialog.complete",facebookAPI.receivedDataCallback,false);
					}
					intel.xdk.facebook.showAppRequestDialog(params);	
				},
				
				getUser:function (callbackFunction) {
					try { document.removeEventListener("intel.xdk.facebook.request.response"); } catch(e) {}
					if(callbackFunction!='' && callbackFunction!=undefined && callbackFunction!='undefined' && callbackFunction!=null){
						facebookAPI.receivedDataCallback=callbackFunction;
						document.addEventListener("intel.xdk.facebook.request.response",function(e){
							if (e.success == true) {
								this.me = e.data;
                                console.log("Me = "+ this.me);
                                console.log(e);
							} 
							
							//remove the event handler
							document.removeEventListener("intel.xdk.facebook.request.response");
							
							//make the callback
							eval(facebookAPI.receivedDataCallback(this.me));
						
						},false);
					}
					
					intel.xdk.facebook.requestWithGraphAPI("/me","GET",{});
				},
				
				

				//a generic Facebook graph API -- requires path parameter
				friends:function(facebookUserID, callbackFunction) {
					
					if (facebookUserID == "") { facebookUserID = "me"; }
					
					facebookAPI.debug("about to query the Facebook Graph");
				
					try { document.removeEventListener("intel.xdk.facebook.request.response"); } catch(e) {}
					if(callbackFunction!='' && callbackFunction!=undefined && callbackFunction!='undefined' && callbackFunction!=null){
						facebookAPI.receivedDataCallback=callbackFunction;
						document.addEventListener("intel.xdk.facebook.request.response",function(e){
						
							var objFriends = {"success":false};
							if (e.success == true) {
								
								facebookAPI.debug(e);
								facebookAPI.debug(e.data);
								
								objFriends = e.data;
								document.removeEventListener("intel.xdk.facebook.request.response");
							} else { objFriends = e; }
					
							//make the callback
							eval(facebookAPI.receivedDataCallback(objFriends));
						
						},false);
					}
											
					intel.xdk.facebook.requestWithGraphAPI("/me/friends","GET",{});
				},
				
				invite:function(facebookUserID,callbackFunction) {
				
				},
				
				//gets a picture of a Facebook Graph item based on an ID
				picture:function(facebookID) {
					return "http://graph.facebook.com/" + facebookID + "/picture";
				},
				
				debug:function(debugMessage) {
					if (this.debugMode == 1) {
						console.log(debugMessage);
					}
					if (this.debugMode == 2) {
						alert(debugMessage);
					}
				},
				
				logout:function(callbackFunction) {
					try { document.removeEventListener("intel.xdk.facebook.logout"); } catch(e) {}
					if(callbackFunction!='' && callbackFunction!=undefined && callbackFunction!='undefined' && callbackFunction!=null){
						facebookAPI.receivedDataCallback=callbackFunction;
						document.addEventListener("intel.xdk.facebook.logout",facebookAPI.receivedDataCallback,false);
					}				
					intel.xdk.facebook.logout();
				}
			
			}
		}();