var me;
// JavaScript Document
var LuckyLapsDB =  {
    db: null,
    init: function () {
        me = this;
     // $("#debug2").html('<br/>##Loading Database ...');
        // allocate a 100mb database
        
        this.db = openDatabase('LuckyLaps', '1.0', 'LuckyLaps Database', 45 * 1024 * 1024);
        
        
//     DROP TABLES  
//        $("#debug2").html('<br/>##Database Loaded...');
//        
//         this.db.transaction(function (tx) {
//            tx.executeSql('DROP TABLE IF EXISTS "User" ', [], this.onSuccess, this.onError);
//         });
//         
//         this.db.transaction(function (tx) {
//            tx.executeSql('DROP TABLE IF EXISTS "user" ', [], this.onSuccess, this.onError);
//         });
//         
//         this.db.transaction(function (tx) {
//            tx.executeSql('DROP TABLE IF EXISTS "Event" ', [], this.onSuccess, this.onError);
//         });
//         
//          this.db.transaction(function (tx) {
//            tx.executeSql('DROP TABLE IF EXISTS "Driver" ', [], this.onSuccess, this.onError);
//         });
//         this.db.transaction(function (tx) {
//            tx.executeSql('DROP TABLE IF EXISTS "GameCard" ', [], this.onSuccess, this.onError);
//         });
//           this.db.transaction(function (tx) {
//            tx.executeSql('DROP TABLE IF EXISTS "Score" ', [], this.onSuccess, this.onError);
//         });
//         this.db.transaction(function (tx) {
//            tx.executeSql('DROP TABLE IF EXISTS "DriverRank" ', [], this.onSuccess, this.onError);
//         });
//         this.db.transaction(function (tx) {
//            tx.executeSql('DROP TABLE IF EXISTS "fbUser" ', [], this.onSuccess, this.onError);
//         });
//     
    




        // create the tables
        /*
        |*****************************************************|
        |                                                     |
        |                     USER TABLE                      |
        |                                                     |
        |*****************************************************|
        */
        this.db.transaction(function (tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS  "User" (id INTEGER PRIMARY KEY  NOT NULL,userId INTEGER, email TEXT, username TEXT, password TEXT)', [], this.onSuccess, this.onError);
        });

        /*
        |*****************************************************|
        |                                                     |
        |                     fbUSER TABLE                    |
        |                                                     |
        |*****************************************************|
        */
        this.db.transaction(function (tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS  "fbUser" (id INTEGER PRIMARY KEY  NOT NULL,userId INTEGER,fbUserId TEXT, email TEXT, username TEXT, lastname TEXT, firstname TEXT, gender TEXT)', [], this.onSuccess, this.onError);
        });
         /*
        |*****************************************************|
        |                                                     |
        |                     EVENT TABLE                      |
        |                                                     |
        |*****************************************************|
        */
        this.db.transaction(function (tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS "Event" (id INTEGER PRIMARY KEY  NOT NULL , eventId INTEGER, eventName VARCHAR, eventLocation VARCHAR, eventCutOff DATETIME, eventVisible INTEGER, eventStatus INTEGER, gameCardType INTEGER, secsToGMT INTEGER, eventCreatedAt DATETIME, eventDate DATETIME, eventUpdatedAt DATETIME, eventTime DATETIME, eventTimeZone VARCHAR, hasMidRaceResults INTEGER DEFAULT 0)', [], this.onSuccess, this.onError);
        });
        
        /*
        |*****************************************************|
        |                                                     |
        |                     Driver TABLE                    |
        |                                                     |
        |*****************************************************|
        */
        this.db.transaction(function (tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS "Driver" (id INTEGER PRIMARY KEY  NOT NULL , driverId INTEGER, eventId INTEGER, name VARCHAR, carNb VARCHAR, image VARCHAR)', [], this.onSuccess,  this.onError);
        });
        /*
        |*****************************************************|
        |                                                     |
        |                     GameCard TABLE                    |
        |                                                     |
        |*****************************************************|
        */
        this.db.transaction(function (tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS "GameCard" (id INTEGER PRIMARY KEY  NOT NULL , cell1 VARCHAR ,cell2 VARCHAR, cell3 VARCHAR, cell4 VARCHAR, cell5 VARCHAR, cell6 VARCHAR,  cell7 VARCHAR, cell8 VARCHAR, cell9 VARCHAR, eventId INTEGER, cardId INTEGER, userId INTEGER)', [], this.onSuccess,  this.onError);
        });
        /*
        |*****************************************************|
        |                                                     |
        |                     Score TABLE                    |
        |                                                     |
        |*****************************************************|
        */
        this.db.transaction(function (tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS "Score" (id INTEGER PRIMARY KEY NOT NULL ,resultId INTEGER   NOT NULL ,eventId INTEGER NOT NULL ,type INTEGER NOT NULL ,r_cell1 INTEGER NOT NULL ,r_cell2 INTEGER NOT NULL ,r_cell3 INTEGER NOT NULL ,r_cell4 INTEGER NOT NULL ,r_cell5 INTEGER NOT NULL ,r_cell6 INTEGER NOT NULL ,r_cell7 INTEGER NOT NULL ,r_cell8 INTEGER NOT NULL ,r_cell9 INTEGER NOT NULL ,res123 INTEGER NOT NULL ,res264 INTEGER NOT NULL ,res718 INTEGER NOT NULL ,res593 INTEGER NOT NULL ,res275 INTEGER NOT NULL ,res619 INTEGER NOT NULL ,res483 INTEGER NOT NULL ,res415 INTEGER,total INTEGER,lapNb INTEGER,userId INTEGER)', [], this.onSuccess,  this.onError);
        });
        
         /*
        |*****************************************************|
        |                                                     |
        |                     DriverRank TABLE                    |
        |                                                     |
        |*****************************************************|
        */
        this.db.transaction(function (tx) {
            tx.executeSql('CREATE TABLE IF NOT EXISTS "DriverRank" (id INTEGER PRIMARY KEY NOT NULL , driverId INTEGER NOT NULL , eventId INTEGER NOT NULL , carNb VARCHAR NOT NULL , rank INTEGER NOT NULL , lapNb INTEGER NOT NULL , name VARCHAR);', [], this.onSuccess,  this.onError);
        });
        
        
        
        
        
        return this.db;
    }, 

   runQuery : function(sql, callback) {
       me = this;
        this.db.transaction(function (tx) {
            tx.executeSql(sql, 
                          [],
                          function(tx,rs) {
                            var a = [];
                            for (var i=0; i < rs.rows.length; i++) {
                                a[a.length] = rs.rows.item(i);
                            }
                            callback(a);
                          },
                          function() {             
                            console.log('fail',arguments);
                               $("#debug1").append('<br/>Db Error runQuery ...');
                          }
            );
        });
    },

    writeRecord : function(tablename,id,fields,where,callback) {
        me = this;
       var sql = "";
        var aValues = [];
        if (id === null || id === "") {
            // insert
            var aFields = [], aPlaceHolders = [];
            for (var i=0; i<fields.length; i++) {
               aFields.push(fields[i].name);
               aValues.push(fields[i].value);
               aPlaceHolders.push('?');
            }
            sql = 'INSERT INTO ' + tablename + ' (' + aFields.join(',') + ') VALUES (' + aPlaceHolders.join(',') + ')';
           
            this.db.transaction(function (tx) {
                tx.executeSql(sql, 
                              aValues,
                              function() {
                                callback(arguments);
                              },
                              function() {
                                console.log('db insertion error', arguments);
                              });
            });

        } else {
            sql = "update " + tablename + " set ";
            
            for (var i=0; i<fields.length; i++) {
                sql+= fields[i].name + " = ?";
                aValues.push(fields[i].value);
                if (i < fields.length - 1)
                    sql += ', ';
            }
           if (where !== null || where !== "") { 
               
               //where should be in the form "where id = ?"
            sql += where;
           }
            
            aValues.push(id);
            console.log("Update SQL = " + sql);
            this.db.transaction(function (tx) {
               tx.executeSql(
                    sql,
                    aValues,
                    function() {
                        callback(arguments);
                    },
                    function() {
                        console.log('db insertion error', arguments);
                    }
                );
            });


        }

    },

   importTable : function (tablename, aData) {
       me = this;
        this.db.transaction(function (tx) {
            tx.executeSql('delete from ' + tablename);
        });

        if (aData.length > 0) {

            // build SQL expression   
            var aFields = [],
                aPlaceHolders = [];
            for (var key in aData[0]) {
                aFields.push(key);
                aPlaceHolders.push('?');
            }
            var sql = 'INSERT INTO ' + tablename + ' (' + aFields.join(',') + ') VALUES (' + aPlaceHolders.join(',') + ')';

            // write data to db
            this.db.transaction(function (tx) {

                for (var i = 0; i < aData.length; i++) {
                    var aValues = [];

                    for (var key in aData[i]) {
                        aValues.push(aData[i][key]);
                    }

                    tx.executeSql(sql,
                    aValues,

                    function () {
                        console.log('inserted row');
                    },

                    function () {
                        console.log('failed', arguments);
                    });
                }
            });
        }
    },

    onError : function (tx, e) {
        alert("Error: " + e.message);
    },
    
    onSuccess : function (e) {
        console.log('dbsuccess', e);
    }
};
  LuckyLapsDB.init();

