var self;
var Event = {
    
    eventId : 0, 
    eventName : null, 
    eventLocation : null, 
    eventCutOff : null, 
    eventVisible : false, 
    eventStatus : 0, 
    gameCardType : 0, 
    secsToGMT : 0, 
    eventCreatedAt : null, 
    eventDate : null, 
    eventUpdatedAt : null, 
    eventTime : null, 
    eventTimeZone : null, 
    hasMidRaceResults: 0,
    eventLocal : false,
    eventIsUpToDate : false,
    
    init: function(){   
     self = this;
     this.getEventLocal();   
    },
    
    saveEvent: function(){
        //Save only if we have an eventId
        if(self.eventId != 0)
        {
        var data = [
                  {
                      name: "eventId",
                      value: self.eventId
                  },
                  {
                      name: "eventName",
                      value: self.eventName
                  },
                  {
                      name: "eventLocation",
                      value: self.eventLocation
                  },
                  {
                      name: "eventCutOff",
                      value: self.eventCutOff
                  },
                  {
                      name: "eventVisible",
                      value: self.eventVisible
                  },
                  {
                      name: "eventStatus",
                      value: self.eventStatus
                  },
                  {
                      name: "gameCardType",
                      value: self.gameCardType
                  },
                  {
                      name: "secsToGMT",
                      value: self.secsToGMT
                  },
                  {
                      name: "eventCreatedAt",
                      value: self.eventCreatedAt
                  },
                  {
                      name: "eventDate",
                      value: self.eventDate
                  },
                  {
                      name: "eventUpdatedAt",
                      value: self.eventUpdatedAt
                  },
                  {
                      name: "eventTime",
                      value: self.eventTime
                  },
                  {
                      name: "eventTimeZone",
                      value: self.eventTimeZone
                  },
                  {
                      name: "hasMidRaceResults",
                      value: self.hasMidRaceResults
                  }
                  
              ];
        
        LuckyLapsDB.writeRecord("event",null,data,null, function(e){
            console.log("e.code : " + e.code);
            //var message = "HTTP CODE : " + e.code + "\n There was an error saving user Info";
            //intel.xdk.notification.alert(message,"Create Account","OK");
        }); 
        }
    },
    
    getEventLocalCallback : function(callback){
    self = this;
        //alert("GetEvent Callback Called");

        var sql = ('SELECT * from event ORDER BY eventId desc Limit 1');
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Record Length : " + record.length);

        if(record.length == 1){
       // alert("We have an Event");
            self.eventId = record[0].eventId;
            self.eventName = record[0].eventName; 
            self.eventLocation = record[0].eventLocation; 
            self.eventCutOff = record[0].eventCutOff; 
            self.eventVisible = record[0].eventVisible; 
            self.eventStatus = record[0].eventStatus; 
            self.gameCardType = record[0].gameCardType ; 
            self.secsToGMT = record[0].secsToGMT; 
            self.eventCreatedAt = record[0].eventCreatedAt;
            self.eventDate = record[0].eventDate ;
            self.eventUpdatedAt = record[0].eventUpdatedAt; 
            self.eventTime = record[0].eventTime; 
            self.eventTimeZone = record[0].eventTimeZone; 
            self.hasMidRaceResults = record[0].hasMidRaceResults;
            g_EventStatus = self.eventStatus;
            self.eventLocal = true;
            g_EventId = self.eventId;
            g_EventName = self.eventName;
            g_hasMidRaceResults = self.hasMidRaceResults;
           
            processEvent(self);
        }
        else{
          
           //alert("We dont have an Event calling process user");
           		processEvent(self);
           	
        }
        
                 
        }); 
    },
    getEventLocal: function(){
        'use strict';
        //console.log("GetEvent Called");

        var sql = ('SELECT * from event ORDER BY eventId desc Limit 1');
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Record Length : " + record.length);

        if(record.length == 1){
            self.eventId = record[0].eventId;
            self.eventName = record[0].eventName; 
            self.eventLocation = record[0].eventLocation; 
            self.eventCutOff = record[0].eventCutOff; 
            self.eventVisible = record[0].eventVisible; 
            self.eventStatus = record[0].eventStatus; 
            self.gameCardType = record[0].gameCardType ; 
            self.secsToGMT = record[0].secsToGMT; 
            self.eventCreatedAt = record[0].eventCreatedAt;
            self.eventDate = record[0].eventDate ;
            self.eventUpdatedAt = record[0].eventUpdatedAt; 
            self.eventTime = record[0].eventTime; 
            self.eventTimeZone = record[0].eventTimeZone; 
            self.hasMidRaceResults = record[0].hasMidRaceResults;
            g_EventStatus = self.eventStatus;
            self.eventLocal = true;
            g_EventId = self.eventId;
            g_EventName = self.eventName;
            g_hasMidRaceResults = self.hasMidRaceResults;
        } 
        
                 // console.log("Record Event NAme  : " + self.eventName);
        }); 
    },
    updateEventStatus: function(_status, _eventId)
    {
         var data = [               
                  {
                      name: "eventStatus",
                      value: _status
                  }];
            LuckyLapsDB.writeRecord("event",_eventId,data, function(e){
            console.log("e.code : " + e.code);
            //var message = "HTTP CODE : " + e.code + "\n There was an error saving user Info";
            //intel.xdk.notification.alert(message,"Create Account","OK");
        }); 
    },
    updateEvent : function(){
          var data = [               
                  {
                      name: "eventName",
                      value: self.eventName
                  },
                  {
                      name: "eventLocation",
                      value: self.eventLocation
                  },
                  {
                      name: "eventCutOff",
                      value: self.eventCutOff
                  },
                  {
                      name: "eventVisible",
                      value: self.eventVisible
                  },
                  {
                      name: "eventStatus",
                      value: self.eventStatus
                  },
                  {
                      name: "gameCardType",
                      value: self.gameCardType
                  },
                  {
                      name: "secsToGMT",
                      value: self.secsToGMT
                  },
                  {
                      name: "eventCreatedAt",
                      value: self.eventCreatedAt
                  },
                  {
                      name: "eventDate",
                      value: self.eventDate
                  },
                  {
                      name: "eventUpdatedAt",
                      value: self.eventUpdatedAt
                  },
                  {
                      name: "eventTime",
                      value: self.eventTime
                  },
                  {
                      name: "eventTimeZone",
                      value: self.eventTimeZone
                  },
                  {
                      name: "hasMidRaceResults",
                      value: self.hasMidRaceResults
                  }
                  
              ];
        LuckyLapsDB.writeRecord("event",self.eventId,data,"where eventId = ?", function(e){
           // console.log("e.code : " + e.code);
            //var message = "HTTP CODE : " + e.code + "\n There was an error saving user Info";
            //intel.xdk.notification.alert(message,"Create Account","OK");
        }); 
    },
    getEventServer:function(){
         self = this;
          var url =  baseURL + getEventURL + token +"/?v=" + apiVersion; 
         // console.log("Event URL SERVER"+ url);
          var data = {
                    email: localStorage.getItem("email"),
                    username: localStorage.getItem("username"),
                    password: localStorage.getItem("password"),
                    userId: localStorage.getItem("userId"),
                    };
                    
         $.ajax({
            url:url,
            type:'POST',
            //data:data,
            success:function(result){	
               //console.log("RESPONSE : " + result);
               
                var response = $.parseJSON(result);
               // console.log("drivers : " + response.drivers);
                
                 $.ui.hideMask();
         $.ui.unblockUI();
          intel.xdk.notification.hideBusyIndicator();
                if(response.code == 200)
                {
                    //Set Event Details
                  
                    self.eventId = response.eventId;
                    self.eventName = response.eventName; 
                    self.eventLocation = response.eventLocation; 
                    self.eventCutOff = response.eventCutOff; 
                    self.eventVisible = response.eventVisible; 
                    self.eventStatus = response.eventStatus; 
                    self.gameCardType = response.eventType ; 
                    self.secsToGMT = response.secsToGMT; 
                    self.eventCreatedAt = response.created_at;
                    self.eventDate = response.eventDate ;
                    self.eventUpdatedAt = response.updated_at; 
                    self.eventTime = response.eventTime; 
                    self.eventTimeZone = response.eventTimeZone; 
                    self.hasMidRaceResults = response.hasMidRaceResults;
                    g_EventId = self.eventId;
                    g_EventStatus = self.eventStatus;
                    g_EventName = self.eventName;
                    g_hasMidRaceResults = self.hasMidRaceResults;
                    //console.log("GET SERVER eventID: " + self.eventId);
                    //Will need to review this to save or not to save drivers at this stage??
                    //it should not be a problem because either way we will update the list.
                    //NEED TO CONFIRM ALL THIS
                    //Use write data to trigger saving drivers
                    /* COMMENTUING THIS FOR NOW
                    if(saveDrivers === "true")
                    {
                        for(var i=0; i< response.drivers.length ; i++)
                        {
                          var driver = response.drivers[i];
                          console.log("DriverId : " + driver.driverId + " | Driver Name : " + driver.name + " | " + driver.carNb);

                          var aDriver = Object.create(Driver);
                          var data =[
                              {
                                 name:"eventId",
                                 value :self.eventId
                              },
                              {
                                name:"driverId",
                                value:driver.driverId,
                              },
                              {
                                  name:"name",
                                value:driver.name,
                              },
                              {
                                 name:"carNb",
                                value:driver.carNb, 
                              }
                          ];
                          aDriver.saveDriver(data);  
                        }
                    }
                   */
                }
                else
                {
                    setTimeout(function(){
                    var message = "HTTP CODE : " + response.code + "\n" + response.message;
                    if(self.eventLocal === false)
                    {
                        intel.xdk.notification.alert(response.message,"Race Event","OK");
                    }
                    }, 500);
                }
                
            }
        });
    },
    getAllEvents: function(){
        'use strict';
       // console.log("Get All Events Called");
    self= this;
        var sql = ('SELECT * from event ORDER BY eventId DESC');
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Record Length : " + record.length);

        if(record.length > 0){
            var eventItem = $("#tplEventsItem").html();
            var eventsList = $("#eventsList");
            eventsList.html("");
            for(var i=0; i< record.length; i++)
            {
                var anEvent = record[i];
                    //console.log("id : " + anEvent.id + " | eventId : " +anEvent.eventId + " | Name : " + anEvent.eventName + " | Date : " + anEvent.eventDate);
                    var image = "img/" +  anEvent.eventLocation.replace(/\s+/g,"_") + ".png";
                //console.log("image url = " + image);
               
                var d = anEvent.eventDate.split("-");
                var t = anEvent.eventTime.split(":");
                var am_pm = "AM";
                var date = (d[1])+"-"+d[2]+"-"+d[0];
                if(t[0] > 12){ t[0] = t[0] - 12; am_pm = "PM";}
                var time = t[0]+":"+t[1]+":"+t[2]+" "+am_pm;
                
                    //eventsList.append(eventItem.format(anEvent.eventId,anEvent.eventName,anEvent.eventLocation, anEvent.eventDate, anEvent.eventTime, image));
                eventsList.append(eventItem.format(anEvent.eventId,anEvent.eventName,anEvent.eventLocation, date, time, image));
                if(i == 0)
                {
                    g_EventStatus = anEvent.eventStatus;
                    g_EventId = anEvent.eventId;
                    g_EventName = anEvent.eventName;
                    g_hasMidRaceResults = anEvent.hasMidRaceResults; 
                }
            }
            //eventsList.listview("refresh");
        } 
         //console.log("Get Events Finished Called");
        $.ui.hideMask();
        $.ui.unblockUI();
        intel.xdk.notification.hideBusyIndicator();
        //getLocation();
         //console.log("Calling Location Methods from getAllEvents");
        initGetLocation();
        //initBgLocation();
                //  console.log("Record Event NAme  : " + self.eventName);
        });  
        
    },
    getEventById: function(id){
        self = this;
        
        //console.log("GetEventById Called");

        var sql = 'SELECT * from event where eventId = ' + id;
        LuckyLapsDB.runQuery(sql,function(record){ 

        if(record.length == 1){
            self.eventId = record[0].eventId;
            self.eventName = record[0].eventName; 
            self.eventLocation = record[0].eventLocation; 
            self.eventCutOff = record[0].eventCutOff; 
            self.eventVisible = record[0].eventVisible; 
            self.eventStatus = record[0].eventStatus; 
            self.gameCardType = record[0].gameCardType ; 
            self.secsToGMT = record[0].secsToGMT; 
            self.eventCreatedAt = record[0].eventCreatedAt;
            self.eventDate = record[0].eventDate ;
            self.eventUpdatedAt = record[0].eventUpdatedAt; 
            self.eventTime = record[0].eventTime; 
            self.eventTimeZone = record[0].eventTimeZone; 
            self.hasMidRaceResults = record[0].hasMidRaceResults; 
            //g_EventStatus = self.eventStatus;
            var eventDetails;
            if(self.eventId === g_EventId)
                eventDetails = $("#tplEventDetails").html();
            else
                eventDetails = $("#tplEventDetails_alt").html();
           
            var eventDetailsDiv = $("#event_detailssub");
            eventDetailsDiv.html('');
            var d = self.eventDate.split("-");
                var t = self.eventTime.split(":");
                var am_pm = "AM";
                var date = (d[1])+"-"+d[2]+"-"+d[0];
                if(t[0] > 12){ t[0] = t[0] - 12; am_pm = "PM";}
                var time = t[0]+":"+t[1]+":"+t[2]+" "+am_pm;
                
             eventDetailsDiv.append(eventDetails.format(self.eventName,self.eventLocation, date, time,self.eventId));
        } 
        
                
        }); 
        
        
    },
    getEventInfo: function(id){
        self = this;
        
        //console.log("getEventInfo Called for Event Id : " + id);

        var sql = 'SELECT * from event where eventId = ' + id;
        LuckyLapsDB.runQuery(sql,function(record){ 

        if(record.length == 1){
            self.eventId = record[0].eventId;
            self.eventName = record[0].eventName; 
            self.eventLocation = record[0].eventLocation; 
            self.eventCutOff = record[0].eventCutOff; 
            self.eventVisible = record[0].eventVisible; 
            self.eventStatus = record[0].eventStatus; 
            self.gameCardType = record[0].gameCardType ; 
            self.secsToGMT = record[0].secsToGMT; 
            self.eventCreatedAt = record[0].eventCreatedAt;
            self.eventDate = record[0].eventDate ;
            self.eventUpdatedAt = record[0].eventUpdatedAt; 
            self.eventTime = record[0].eventTime; 
            self.eventTimeZone = record[0].eventTimeZone; 
            self.hasMidRaceResults = record[0].hasMidRaceResults; 
            //g_EventStatus = self.eventStatus;
            //console.log("getEventInfo Called Event NAme: " + self.eventName);
        } 
        
                
        }); 
        
        
    },
    
    
    
    
}







    
