var self;
var GameCard = {
    
    id:0,
    cell1:null,
    cell2:null,
    cell3:null,
    cell4:null,
    cell5:null,
    cell6:null,
    cell7:null,
    cell8:null,
    cell9:null,
    cardExists:false,
    eventId:0,
    cardId:0,
    userId:g_userId,
    driversArray:[],
    dbDriversArray:[],
    data:[],
    
    init:function(){
        
        self = this;
        //console.log("Game Card Init EventId : " + g_EventId);
        //console.log("Game Card Init UserId : " + g_userId);
        //console.log("Game Card Init EventId : " + g_EventName);
        self.driversArray =[];
        self.dbDriversArray = [];
        self.data = [];
        self.cell1 = null;
        self.cell2 = null;
        self.cell3 = null;
        self.cell4 = null;
        self.cell5 = null;
        self.cell6 = null;
        self.cell7 = null;
        self.cell8 = null;
        self.cell9 = null;
        self.eventId = g_EventId;
        self.userId = g_userId;
        if(self.eventId != 0 )
            self.getCard();
        else
        {
            $.ui.hideMask(); 
            intel.xdk.notification.alert("There is no active Race Event for the moment please try again later.","GameCard","OK");  
        }
    },
    saveCard:function(data){
        self = this;
         LuckyLapsDB.writeRecord("GameCard",null,data,null, function(e){
           // console.log("e.code : " + e.code);
            //var message = "HTTP CODE : " + e.code + "\n There was an error saving user Info";
            //intel.xdk.notification.alert(message,"Create Account","OK");
        });   
    },
    getDrivers:function(){
      self = this;      
          var sql ='SELECT * from Driver where eventId = ' + self.eventId;
          LuckyLapsDB.runQuery(sql,function(record){

          if(record.length >= 1){
              for(var i=0; i< record.length ; i++)
              {
                  var myDriver = record[i];
                  self.dbDriversArray.push({ id:myDriver.driverId, name:myDriver.name, carNb: myDriver.carNb});
              }
          } 
    });
    },
    getCard:function(){
        
        self = this;
        self.cardExists = false;
        self.getDrivers();
        // alert("Game Card GetCard g_EventId : " + g_EventId);
        var sql ='SELECT * from GameCard where eventId = ' + self.eventId;
          LuckyLapsDB.runQuery(sql,function(record){
        
      // console.log('<br/>geGaneCard...');
       // console.log('<br/>Record Length' + record.length);
      
          if(record.length == 1){
              // console.log("We have a gamecard");
              self.id = record[0].id;
              self.userId = record[0].userId;
              self.eventId = record[0].eventId;
              self.cardId = record[0].cardId;
              self.cell1 = record[0].cell1;
              self.cell2 = record[0].cell2;
              self.cell3 = record[0].cell3;
              self.cell4 = record[0].cell4;
              self.cell5 = record[0].cell5;
              self.cell6 = record[0].cell6;
              self.cell7 = record[0].cell7;
              self.cell8 = record[0].cell8;
              self.cell9 = record[0].cell9;
              self.cardExists = true;
              g_gameCardHasData = true;
              self.loadDriverArray();
             //$("#submit_gamecard").html("Update");
              $("#submit_gamecard").css("visibility", "visible");
              $("#submit_gamecard2").html("Update");
          } 
        self.displayCard();
    });
    },
    getDBGameCardId:function(_eventId){
        
        var anId = 0;
         var sql ='SELECT id from GameCard where eventId = ' + self.eventId;
          LuckyLapsDB.runQuery(sql,function(record){
          if(record.length == 1){
             anId = record[0].id;
          } 
        return anId;
    });  
    },
    updateCard:function(data){        
        self = this;
        if(g_EventStatus >=2)
        {
            //Event is already @ Frozen Status at least
            var message = "Sorry,This Race is already in progress!  You cannot submit a new GameCard, or make changes to an existing one. If you already have a  Game Card for this race, we'll reload it now.";
            intel.xdk.notification.alert(message,"Update GameCard","OK");  
        }
        else
        {
           var where = " where cardId = ?";
            //console.log("Updating Card: " + " | CardId : " + self.cardId + " | id : " + self.id);
             LuckyLapsDB.writeRecord("GameCard",self.cardId,data,where, function(e){

        });   
        }
    },
    getCardServer:function(){
                // All Values are present We can post
               // console.log("GameCard getCardServer Event Status + " + g_EventStatus);
               // console.log("GameCard getCardServer Event id + " + g_EventId);
                var params = {
                                eventId : g_EventId,
                                userId : g_userId,
                                cardId : 0,
                                };
                var url = baseURL + getGamecardURL + token + "?v=" + apiVersion; 
                //console.log("url :", url);
                $.ajax({
                    url:url,
                    type:'POST',
                    data:params,
                    success:function(result){	
                       
                        var response = $.parseJSON(result);
                        
                        /*
                        var html1    =   "Cell1: "+ self.cell1 + "\n";
                            html1    +=  "Cell2: "+ self.cell2 + "\n";
                            html1    +=  "Cell3: "+ self.cell3 + "\n";
                            html1    +=  "Cell4: "+ self.cell4 + "\n";
                            html1    +=  "Cell5: "+ self.cell5 + "\n";
                            html1    +=  "Cell6: "+ self.cell6 + "\n";
                            html1    +=  "Cell7: "+ self.cell7 + "\n";
                            html1    +=  "Cell8: "+ self.cell8 + "\n";
                            html1    +=  "Cell9: "+ self.cell9 + "\n";
                            html1    +=  "EvemntId: "+ self.eventId + "\n";
                            html1    +=  "userId: "+ self.userId + "\n";
                            html1    +=  "cardId: "+ self.cardId + "\n";
                        
                        console.log(html1);
                        */
                        if (response.code == 200)
                        {
                             //Create GameCard From Server Data
                            var myCard = response.card;
                            self.cardId = myCard.cardId;
                            self.cell1 = myCard.cell1;
                            self.cell2 = myCard.cell2;
                            self.cell3 = myCard.cell3;
                            self.cell4 = myCard.cell4;
                            self.cell5 = myCard.cell5;
                            self.cell6 = myCard.cell6;
                            self.cell7 = myCard.cell7;
                            self.cell8 = myCard.cell8;
                            self.cell9 = myCard.cell9;
                            self.eventId = myCard.eventId;
                            self.userId = myCard.userId;
                            self.cardExists = true;
                            
                             var data =[
                              {
                                 name:"cell1",
                                 value :self.cell1
                              },
                              {
                                name:"cell2",
                                value:self.cell2
                              },
                              {
                                  name:"cell3",
                                value:self.cell3
                              },
                              {
                                 name:"cell4",
                                value:self.cell4 
                              },
                              {
                                 name:"cell5",
                                value:self.cell5 
                              },
                              {
                                 name:"cell6",
                                value:self.cell6 
                              },
                              {
                                 name:"cell7",
                                value:self.cell7 
                              },
                              {
                                 name:"cell8",
                                value:self.cell8 
                              },
                              {
                                 name:"cell9",
                                value:self.cell9 
                              },
                              {
                                 name:"eventId",
                                value:self.eventId 
                              },
                              {
                                 name:"userId",
                                value:self.userId 
                              },
                              {
                                 name:"cardId",
                                value:self.cardId 
                              }
                          ];
                            self.saveCard(data);
                             self.id = self.getDBGameCardId(self.event);
                            setTimeout(function(){
                            				$("#submit_gamecard2").html("Update");
                            				
                            				self.displayFull()
                            				}, 500);
                           
                        }
                        else if(response.code == 204 && g_EventStatus < 2)
                        {
                           
                            self.cardExists = false;
                           self.displayEmpty();
                        }
                        else if(response.code == 204 && g_EventStatus >= 2)
                        {
                            $.ui.hideMask();
                            var message = "Sorry,This Race is already in progress or at a final Status,  You cannot submit a new GameCard, or make changes to an existing one. If you already have a  Game Card for this race, we'll reload it now.";
            intel.xdk.notification.alert(message,"GameCard","OK");   
                        }
                    }
                });
                    
        
    },
    postCard:function(){
    
         self = this;
         self.userId = g_userId;
        if(g_EventStatus >=2)
        {
            //Event is already @ Frozen Status at least
            var message = "Sorry,This Race is already in progress!  You cannot submit a new GameCard, or make changes to an existing one. If you already have a  Game Card for this race, we'll reload it now.";
            intel.xdk.notification.alert(message,"GameCard","OK");  
        }
        else
        {
            //If last Event Status Local is IN PROGRESS
            //POST DATA To Server
            //Server needs to check Event Status before allowing creation of GameCard.
            //We need to check that we have 9 values before posting
            if( self.cell1 !== null && self.cell2 !== null && self.cell3 !== null && self.cell4 !== null && self.cell5 !== null && self.cell6 !== null && self.cell7 !== null && self.cell8 !== null && self.cell9 !== null)
            {
                // All Values are present We can post
                var params = {
                    
                                cell1 : self.cell1,
                                cell2 : self.cell2,
                                cell3 : self.cell3,
                                cell4 : self.cell4,
                                cell5 : self.cell5,
                                cell6 : self.cell6,
                                cell7 : self.cell7,
                                cell8 : self.cell8,
                                cell9 : self.cell9,
                                eventId : self.eventId,
                                userId : g_userId,
                                cardId : self.cardId,
                                };
                var url = baseURL + postGamecardURL + token + "?v=" + apiVersion; 
                $.ajax({
                    url:url,
                    type:'POST',
                    data:params,
                    success:function(result){	
                        var response = $.parseJSON(result);
                        //console.log("GameCard Result :", result);
                        var html1    =   "Cell1: "+ self.cell1 + "\n";
                            html1    +=  "Cell2: "+ self.cell2 + "\n";
                            html1    +=  "Cell3: "+ self.cell3 + "\n";
                            html1    +=  "Cell4: "+ self.cell4 + "\n";
                            html1    +=  "Cell5: "+ self.cell5 + "\n";
                            html1    +=  "Cell6: "+ self.cell6 + "\n";
                            html1    +=  "Cell7: "+ self.cell7 + "\n";
                            html1    +=  "Cell8: "+ self.cell8 + "\n";
                            html1    +=  "Cell9: "+ self.cell9 + "\n";
                            html1    +=  "EvemntId: "+ self.eventId + "\n";
                            html1    +=  "userId: "+ self.userId + "\n";
                            html1    +=  "cardId: "+ self.cardId + "\n";                        
                        //console.log(html1);
                        if(response.code == 200 )
                        {
                            // Update GameCard
                            var message = response.message;
                            intel.xdk.notification.alert(message,"Updating GameCard","OK");
                            var data =[
                              {
                                 name:"cell1",
                                 value :self.cell1
                              },
                              {
                                name:"cell2",
                                value:self.cell2
                              },
                              {
                                  name:"cell3",
                                value:self.cell3
                              },
                              {
                                 name:"cell4",
                                value:self.cell4 
                              },
                              {
                                 name:"cell5",
                                value:self.cell5 
                              },
                              {
                                 name:"cell6",
                                value:self.cell6 
                              },
                              {
                                 name:"cell7",
                                value:self.cell7 
                              },
                              {
                                 name:"cell8",
                                value:self.cell8 
                              },
                              {
                                 name:"cell9",
                                value:self.cell9 
                              }
                            ];
                            self.id = self.getDBGameCardId(self.event);
                            self.updateCard(data);
                            $("#submit_gamecard2").html("Update");
                        }
                        else if (response.code == 201)
                        {
                             //Create GameCard
                            self.cardId = response.cardId;
                            var message = response.message;
                            intel.xdk.notification.alert(message,"Saving GameCard","OK"); 
                             var data =[
                              {
                                 name:"cell1",
                                 value :self.cell1
                              },
                              {
                                name:"cell2",
                                value:self.cell2
                              },
                              {
                                  name:"cell3",
                                value:self.cell3
                              },
                              {
                                 name:"cell4",
                                value:self.cell4 
                              },
                              {
                                 name:"cell5",
                                value:self.cell5 
                              },
                              {
                                 name:"cell6",
                                value:self.cell6 
                              },
                              {
                                 name:"cell7",
                                value:self.cell7 
                              },
                              {
                                 name:"cell8",
                                value:self.cell8 
                              },
                              {
                                 name:"cell9",
                                value:self.cell9 
                              },
                              {
                                 name:"eventId",
                                value:self.eventId 
                              },
                              {
                                 name:"userId",
                                value:self.userId 
                              },
                              {
                                 name:"cardId",
                                value:self.cardId 
                              }
                          ];
                            self.saveCard(data);
                            self.id = self.getDBGameCardId(self.event);
                            $("#submit_gamecard2").html("Update");
                        }                        
                        else
                        {
                           var message = response.message;
                            intel.xdk.notification.alert(message,"GameCard","OK"); 
                            if(response.eventStatus != g_EventStatus)
                            {
                                //update Global EventStatus Variable
                                g_EventStatus = response.eventStatus;
                                //Event Status has changed We need to update Current Event
                                var anEvent = Object.create(Event);
                                anEvent.updateEventStatus(response.eventStatus, self.eventId);
                            }
                        }
                    }
                });      
            }
            else{              
                var message = "All Cells need to be filled before submitting a GameCard.";
                intel.xdk.notification.alert(message,"GameCard","OK");   
            }  
        }
    },
    displayCard:function(){
        self = this;
        if(self.cardExists === true)
        {
            //We have a GameCard for this Event display FULL
            self.displayFull();
        }
        else
        {
           //We dont have a gameCard for this Event display Empty 
          //  self.displayEmpty();
             //$("#submit_gamecard").html("Save");
              $("#submit_gamecard2").html("Save");
            self.getCardServer();
        }
    },
    displayEmpty:function(){
        self = this;
        
         $("#gamecard_content").html("");
        //Generate Empty GameCard Visual
        var html = "<h3 class='eventName'>" + g_EventName + "</h3>";
            html +='<table class="gamecard" >';
            //Row 1
            html +='<tr class="tr">';
            html +='<td class="td cell2" id="cell2"><a href="javascript:void(0);"  >Select a Driver</a></td>';  
            html +='<td class="td cell6" id="cell6"><a href="javascript:void(0);"  >Select a Driver</a></td>';  
            html +='<td class="td cell4" id="cell4"><a href="javascript:void(0);"  >Select a Driver</a></td>';  
            html +='</tr>';
            
            //Row 2
            html +='<tr class="tr">';
            html +='<td class="td cell7" id="cell7"><a href="javascript:void(0);"  >Select a Driver</a></td>';  
            html +='<td class="td cell1" id="cell1"><a href="javascript:void(0);"  >Select a Driver</a></td>';  
            html +='<td class="td cell8" id="cell8"><a href="javascript:void(0);"  >Select a Driver</a></td> '; 
            html +='</tr>';
            
            //Row 3
            html +='<tr class="tr">';
            html +='<td class=" td cell5 " id="cell5"><a href="javascript:void(0);"  >Select a Driver</a></td>';  
            html +='<td class="td cell9" id="cell9"><a href="javascript:void(0);"  >Select a Driver</a></td>';  
            html +='<td class="td cell3" id="cell3"><a href="javascript:void(0);"  >Select a Driver</a></td>';  
            html +='</tr>';                        

            html +='</table>';
        	 html += '<a class="button fbButtonBg  buttonPadding " style="width:92% !important ; margin-right:4% !important; margin-left:4% !important;"  id="submit_gamecard2"> Save</a>';
        	
        
        
        /*
        	html +='<div class="grid grid-pad urow uib_row_5 row-height-5" data-uib="layout/row" data-ver="0">';
			html +='	<div class="col uib_col_5 col-0_4-12_4-4" data-uib="layout/col" data-ver="0">';
			html +='		<div class="cell2" id="cell2"><a href="javascript:void(0);"  >Select a Driver</a>';
			html +='		</div>';
            html +='        <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_11 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
            html +='       <div class="cell6" id="cell6"><a href="#gamecard_drivers"  >Select a Driver</a>';
            html +='        </div>';
            html +='        <span class="uib_shim"></span>';	
			html +='	</div>';
            html +='    <div class="col uib_col_12 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
			html +='	    <div class="cell4" id="cell4"><a href="#gamecard_drivers"  >Select a Driver</a>';
            html +='        </div>';
            html +='        <span class="uib_shim"></span>';
			html +='	</div>';
			html +=' <span class="uib_shim"></span>';
			html +='</div>';
			html +='<div class="grid grid-pad urow uib_row_5 row-height-5" data-uib="layout/row" data-ver="0">';
			html +='	<div class="col uib_col_13 col-0_4-12_4-4" data-uib="layout/col" data-ver="0">';
            html +='        <div class="cell7" id="cell7"><a href="#gamecard_drivers"  >Select a Driver</a>';
            html +='	</div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_15 col-0_4-12_4-4" data-uib="layout/col" data-ver="0">';
            html +='	   <div class="cell1" id="cell1" ><a href="javascript:void(0);"  >Select a Driver</a>';
            html +='	   </div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_16 col-0_4-12_4-4" data-uib="layout/col" data-ver="0">';
			html +='	    <div class="cell8" id="cell8"><a href="#gamecard_drivers"  >Select a Driver</a>';
            html +='	   </div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			html +='</div>';
			html +='<span class="uib_shim"></span>';
			html +='<div class="grid grid-pad urow uib_row_11 row-height-11" data-uib="layout/row" data-ver="0">';
			html +='	<div class="col uib_col_14 col-0_4-12_4-4" data-uib="layout/col" data-ver="0">';
			html +='	    <div class="cell5" id="cell5"><a href="#gamecard_drivers"  >Select a Driver</a>';
            html +='	   </div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_17 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
			html +='	    <div class="cell9" id="cell9"><a href="#gamecard_drivers"  >Select a Driver</a>';
            html +='	    </div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_18 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
            html +='	<div class="cell3" id="cell3"><a href="#gamecard_drivers"  >Select a Driver</a>';
            html +='	</div>';
            html +='	<span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<span class="uib_shim"></span>';
			html +='	</div>';
        */
        $("#gamecard_content").html(html);
        $.ui.hideMask();
        //console.log("html = " + html);
    },
    
    displayFull:function(){
        self = this;
        self.eventId = g_EventId;
       // console.log("Displaying Full GameCArd");
        $("#gamecard_content").html("");
        //Get Drivers NAmes
        self.data=[
            {
                _cell:"cell1",
                _href:"javascript:void(0);",
                _class:"cell1",
                _driver:"Select a Driver"
            
            },
            
            {
                _cell:"cell2",
                _href:"javascript:void(0);",
                _class:"cell2",
                _driver:"Select a Driver"
            
            },
            {
                _cell:"cell3",
                _href:"javascript:void(0);",
                _class:"cell3",
                _driver:"Select a Driver"
            
            },
            {
                _cell:"cell4",
                _href:"javascript:void(0);",
                _class:"cell4",
                _driver:"Select a Driver"
            
            },
            {
                _cell:"cell5",
                _href:"javascript:void(0);",
                _class:"cell5",
                _driver:"Select a Driver"
            
            },
            {
                _cell:"cell6",
                _href:"javascript:void(0);",
                _class:"cell6",
                _driver:"Select a Driver"
            
            },
            {
                _cell:"cell7",
                _href:"javascript:void(0);",
                _class:"cell7",
                _driver:"Select a Driver"
            
            },
            {
                _cell:"cell8",
                _href:"javascript:void(0);",
                _class:"cell8",
                _driver:"Select a Driver"
            
            },
            {
                _cell:"cell9",
                _href:"javascript:void(0);",
                _class:"cell9",
                _driver:"Select a Driver"
            
            }
            
            ];
        

        var sql = "";
        
       // console.log("$$$$ EventId : " + self.eventId + " | Cell1 : " + self.cell1 + " | Driver1 : " + self.data[0]._driver);
       // console.log("$$$$ EventId : " + self.eventId + " | Cell2 : " + self.cell2 + " | Driver1 : " + self.data[1]._driver);
       // console.log("$$$$ EventId : " + self.eventId + " | Cell3 : " + self.cell3 + " | Driver1 : " + self.data[2]._driver);
       if(self.cell1 !== null)
       {
           self.findCarNb(self.cell1, "cell1");
           
       }
       if(self.cell2 !== null)
       {
            self.findCarNb(self.cell2, "cell2");
       }
       if(self.cell3 !== null)
       {
            self.findCarNb(self.cell3, "cell3");
       }
       if(self.cell4 !== null)
       {
            self.findCarNb(self.cell4, "cell4");
       }if(self.cell5 !== null)
       {
            self.findCarNb(self.cell5, "cell5");
       }
        if(self.cell6 !== null)
       {
            self.findCarNb(self.cell6, "cell6");
       }
       if(self.cell7 !== null)
       {
            self.findCarNb(self.cell7, "cell7");
       }
       if(self.cell8 !== null)
       {
            self.findCarNb(self.cell8, "cell8");
       }
       if(self.cell9 !== null)
       {
            self.findCarNb(self.cell9, "cell9");
       }
        //Generate Full GameCArd Visual
         var html = "<h3 class='eventName'>" + g_EventName + "</h3>";
        
            html +='<table class="gamecard">';
            //Row 1
            html +='<tr class="tr">';
            html +='<td class="td  '+ self.data[1]._class + '"  id="cell2">';
            html +='<a href="' + self.data[1]._href + '"  >' + self.data[1]._driver + '</a>';
            html +='<span class="carNb">' + ((self.cell2 !== null) ? self.cell2 :"") +'</span>';
            html +='</td>';  
            html +='<td class="td ' + self.data[5]._class +'" id="cell6">';
            html +='<a href="' + self.data[5]._href + '"  >' + self.data[5]._driver + '</a>';  
            html +='<span class="carNb">' + ((self.cell6 !== null) ? self.cell6 :"") +'</span>';
            html +='</td>'; 
            html +='<td class="td ' + self.data[3]._class +'" id="cell4">';
            html +='<a href="' + self.data[3]._href + '"  >' + self.data[3]._driver + '</a>';
            html +='<span class="carNb">' + ((self.cell4 !== null) ? self.cell4 :"") +'</span>';
            html +='</td>'; 
            html +='</tr>';
            
            //Row 2
            html +='<tr class="tr">';
            html +='<td class="td cell7 ' + self.data[6]._class + '" id="cell7">';
            html +='<a href="' + self.data[6]._href+ '"  >' + self.data[6]._driver + '</a>';
            html +='<span class="carNb">' + ((self.cell7 !== null) ? self.cell7 :"") +'</span>';
            html +='</td>';  
            html +='<td class="td cell1 ' + self.data[0]._class +'" id="cell1">';
            html +='<a href="' + self.data[0]._href + '"  >' + self.data[0]._driver + '</a>';
            html +='<span class="carNb">' + ((self.cell1 !== null) ? self.cell1 :"") +'</span>';
            html +='</td>';  
            html +='<td class="td cell8 ' + self.data[7]._class + '" id="cell8">';
            html +='<a href="' + self.data[7]._href + '"  >' + self.data[7]._driver + '</a>';
            html +='<span class="carNb">' + ((self.cell8 !== null) ? self.cell8 :"") +'</span>';
            html +='</td> '; 
            html +='</tr>';
            
            //Row 3
            html +='<tr class="tr">';
            html +='<td class=" td cell5 ' + self.data[4]._class + '" id="cell5">';
            html +='<a href="' + self.data[4]._href +'"  >' + self.data[4]._driver + '</a>';
            html +='<span class="carNb">' + ((self.cell5 !== null) ? self.cell5 :"") +'</span>';
            html +='</td>';  
            html +='<td class="td cell9 ' + self.data[8]._class + '" id="cell9">';
            html +='<a href="' + self.data[8]._href+ '"  >' + self.data[8]._driver + '</a>';
            html +='<span class="carNb">' + ((self.cell9 !== null) ? self.cell9 :"") +'</span>';
            html +='</td>';  
            html +='<td class="td cell3 ' + self.data[2]._class +'" id="cell3">';
            html +='<a href="' + self.data[2]._href +'"  >' + self.data[2]._driver + '</a>';
            html +='<span class="carNb">' + ((self.cell3 !== null) ? self.cell3 :"") +'</span>';
            html +='</td>';  
            html +='</tr>';                        
            html +='</table>';
            html += '<a class="button fbButtonBg  buttonPadding " style="width:92% !important ; margin-right:4% !important; margin-left:4% !important;"  id="submit_gamecard2"> Save</a>';
        	
        /*
        	html +='<div class="grid grid-pad urow uib_row_5 row-height-5" data-uib="layout/row" data-ver="0">';		
            html +='	<div class="col uib_col_5 col-0_4-12_4-4" data-uib="layout/col" data-ver="0">';
			html +='		<div class="'+ self.data[1]._class + '" id="cell2"><a href="' + self.data[1]._href + '"  >' + self.data[1]._driver + '</a>';
			html +='         <span class="carNb">' + ((self.cell2 !== null) ? self.cell2 :"") +'</span>';
            html +='		</div>';
            html +='        <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_11 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
            html +='       <div class="' + self.data[5]._class +'" id="cell6"><a href="' + self.data[5]._href + '"  >' + self.data[5]._driver + '</a>';
            html +='         <span class="carNb">' + ((self.cell6 !== null) ? self.cell6 :"") +'</span>';
            html +='        </div>';
            html +='        <span class="uib_shim"></span>';	
			html +='	</div>';
            html +='    <div class="col uib_col_12 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
			html +='	    <div class="' + self.data[3]._class +'" id="cell4"><a href="' + self.data[3]._href + '"  >' + self.data[3]._driver + '</a>';
            html +='         <span class="carNb">' + ((self.cell4 !== null) ? self.cell4 :"") +'</span>';
            html +='        </div>';
            html +='        <span class="uib_shim"></span>';
			html +='	</div>';
			html +=' <span class="uib_shim"></span>';
			html +='</div>';
			
            html +='<div class="grid grid-pad urow uib_row_5 row-height-5" data-uib="layout/row" data-ver="0">';
			html +='	<div class="col uib_col_13 col-0_4-12_4-4" data-uib="layout/col" data-ver="0">';
            html +='        <div class="' + self.data[6]._class + '" id="cell7"><a href="' + self.data[6]._href+ '"  >' + self.data[6]._driver + '</a>';
            html +='         <span class="carNb">' + ((self.cell7 !== null) ? self.cell7 :"") +'</span>';
            html +='	</div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_15 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
            html +='	   <div class="' + self.data[0]._class +'" id="cell1"><a href="' + self.data[0]._href + '"  >' + self.data[0]._driver + '</a>';
            html +='         <span class="carNb">' + ((self.cell1 !== null) ? self.cell1 :"") +'</span>';
            html +='	   </div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_16 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
			html +='	    <div class="' + self.data[7]._class + '" id="cell8"><a href="' + self.data[7]._href + '"  >' + self.data[7]._driver + '</a>';
            html +='         <span class="carNb">' + ((self.cell8 !== null) ? self.cell8 :"") +'</span>';
            html +='	   </div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
            html +='<span class="uib_shim"></span>';
			html +='</div>';
        
			
			html +='<div class="grid grid-pad urow uib_row_11 row-height-11" data-uib="layout/row" data-ver="0">';
			html +='	<div class="col uib_col_14 col-0_4-12_4-4" data-uib="layout/col" data-ver="0">';
			html +='	    <div class="' + self.data[4]._class + '" id="cell5" ><a href="' + self.data[4]._href +'"  >' + self.data[4]._driver + '</a>';
            html +='         <span class="carNb">' + ((self.cell5 !== null) ? self.cell5 :"") +'</span>';
            html +='	   </div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_17 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
			html +='	    <div class="' + self.data[8]._class + '" id="cell9"><a href="' + self.data[8]._href+ '"  >' + self.data[8]._driver + '</a>';
            html +='         <span class="carNb">' + ((self.cell9 !== null) ? self.cell9 :"") +'</span>';
            html +='	    </div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			html +='	<div class="col uib_col_18 col-0_4-12_4-8" data-uib="layout/col" data-ver="0">';
            html +='	   <div class="' + self.data[2]._class +'" id="cell3"><a href="' + self.data[2]._href +'"  >' + self.data[2]._driver + '</a>';
            html +='         <span class="carNb">' + ((self.cell3 !== null) ? self.cell3 :"") +'</span>';
            html +='	   </div>';
            html +='	   <span class="uib_shim"></span>';
			html +='	</div>';
			
            html +='	<span class="uib_shim"></span>';
			html +='	</div>';
            */
        $("#gamecard_content").html(html);
        $.ui.hideMask();
    },
    
    assignDriverToCell:function(driverId)
    {   
        self = this;
        // console.log("GameCard AssignDriverToCell driverId: " + driverId);
        if(self.driversArray.length === 0 || self.isInArray(driverId) === -1)
        {              
            if(g_isCell1 === true)
            {
                self.assignCellToDriversArray("cell1", driverId);
                
            }
            if(g_isCell2 === true)
            {
                 self.assignCellToDriversArray("cell2", driverId);
            }
            if(g_isCell3 === true)
            {
                 self.assignCellToDriversArray("cell3", driverId);
            }
            if(g_isCell4 === true)
            {
                 self.assignCellToDriversArray("cell4", driverId);
            }
            if(g_isCell5 === true)
            {
                 self.assignCellToDriversArray("cell5", driverId);
            }
            if(g_isCell6 === true)
            {
                 self.assignCellToDriversArray("cell6", driverId);
            }
            if(g_isCell7 === true)
            {
                 self.assignCellToDriversArray("cell7", driverId);
            }
            if(g_isCell8 === true)
            {
                 self.assignCellToDriversArray("cell8", driverId);
            }
            if(g_isCell9 === true)
            {
                 self.assignCellToDriversArray("cell9", driverId);
            }
        }
        else
        {
            //if not then this is a duplicate entry show alert  
             intel.xdk.notification.alert("This Driver is already assigned to a GameCard cell.","Drivers List","OK");
            
        }
        
    },
    isInArray:function(val) {
        self = this;
        
        var found = -1;
        for(var i=0; i<self.driversArray.length; i++) {
            
            if(parseInt(val) === parseInt(self.driversArray[i].id))
            {
                found = true;
                break;
            }
        }
        return found;
    },
    loadDriverArray:function(){
       self = this; 
         //console.log("Loading Driver Array");
        var sql = 'SELECT driverId from driver where carNb = ' + self.cell1 + " and eventId = " + self.eventId;
        LuckyLapsDB.runQuery(sql,function(record){ 
       // console.log("Cell1 : " +self.cell1 + " | Record Length : " + record.length);

        if(record.length == 1){
           self.driversArray.push({id:record[0].driverId,cell:"cell1"});
        } 
        });
       sql = 'SELECT driverId from driver where carNb = ' + self.cell2 + " and eventId = " + self.eventId;
        LuckyLapsDB.runQuery(sql,function(record){ 
       // console.log("Cell2 Record Length : " + record.length);

        if(record.length == 1){
           self.driversArray.push({id:record[0].driverId,cell:"cell2"});
        } 
        });
        sql = 'SELECT driverId from driver where carNb = ' + self.cell3 + " and eventId = " + self.eventId;
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Cell3 Record Length : " + record.length);

        if(record.length == 1){
           self.driversArray.push({id:record[0].driverId,cell:"cell3"});
        } 
        });
        sql = 'SELECT driverId from driver where carNb = ' + self.cell4 + " and eventId = " + self.eventId;
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Cell4 Record Length : " + record.length);

        if(record.length == 1){
           self.driversArray.push({id:record[0].driverId,cell:"cell4"});
        } 
        });
       sql = 'SELECT driverId from driver where carNb = ' + self.cell5 + " and eventId = " + self.eventId;
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Cell5 Record Length : " + record.length);

        if(record.length == 1){
           self.driversArray.push({id:record[0].driverId,cell:"cell5"});
        } 
        });
        sql = 'SELECT driverId from driver where carNb = ' + self.cell6 + " and eventId = " + self.eventId;
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Cell6 Record Length : " + record.length);

        if(record.length == 1){
           self.driversArray.push({id:record[0].driverId,cell:"cell6"});
        } 
        });
        sql = 'SELECT driverId from driver where carNb = ' + self.cell7 + " and eventId = " + self.eventId;
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Cell7 Record Length : " + record.length);

        if(record.length == 1){
           self.driversArray.push({id:record[0].driverId,cell:"cell7"});
        } 
        });
        sql = 'SELECT driverId from driver where carNb = ' + self.cell8 + " and eventId = " + self.eventId;
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Cell8 Record Length : " + record.length);

        if(record.length == 1){
           self.driversArray.push({id:record[0].driverId,cell:"cell8"});
        } 
        });
        sql = 'SELECT driverId from driver where carNb = ' + self.cell9 + " and eventId = " + self.eventId;
        LuckyLapsDB.runQuery(sql,function(record){ 
        //console.log("Cell9 Record Length : " + record.length);

        if(record.length == 1){
           self.driversArray.push({id:record[0].driverId,cell:"cell9"});
        }
             //FOR TESTING TO BE REMOVED
          /*  
        for(var i=0; i<self.driversArray.length; i++) {
                console.log("@@@@Driver Id : " + self.driversArray[i].id + " | Cell : " + self.driversArray[i].cell);   
        }
        */
        });
        
    },
    assignCellToDriversArray:function(aCell, driverId){
       // console.log("######### Game Card assignCellToDriversArray  Drivers Array length #######: " + self.driversArray.length);
       // console.log("######### Game Card assignCellToDriversArray Cell Selected #######: " + aCell);
       // console.log("#########  Game Card assignCellToDriversArray driverID #######: " + driverId);
        
        self = this;
        /*
        for(var i=0; i<self.driversArray.length; i++) {
                console.log("&&&& Driver Id : " + self.driversArray[i].id + " | Cell : " + self.driversArray[i].cell);   
        }
        */
        var found = false;
        // if Drivers Array is Empty insert Value
        if( self.driversArray.length === 0) self.driversArray.push({id:driverId,cell:aCell});
        else
        {
            //Check if a value exists, if it does remove it and replace it with new one
            for(var i=0; i<self.driversArray.length; i++) {
                if(aCell === self.driversArray[i].cell)
                {
                    self.driversArray.splice(i,1);
                    self.driversArray.push({id:driverId,cell:aCell});
                    found = true;
                }

            }
            //We did not find any entry add to array
            if(found === false)  self.driversArray.push({id:driverId,cell:aCell});
        }
        //FOR TESTING TO BE REMOVED
        /*
        for(var i=0; i<self.driversArray.length; i++) {
                console.log("Driver Id : " + self.driversArray[i].id + " | Cell : " + self.driversArray[i].cell);   
        }
        */
       self.assignCellValue(aCell,driverId);
       
    },
    assignCellValue:function(aCell, driverId){
        self = this;        
          sql ='SELECT driver.carNb from Driver where driverId = ' + driverId + " and eventId = " + self.eventId;
          LuckyLapsDB.runQuery(sql,function(record){
          if(record.length == 1){
                if(aCell === "cell1") self.cell1 = record[0].carNb;
                if(aCell === "cell2") self.cell2 = record[0].carNb;
                if(aCell === "cell3") self.cell3 = record[0].carNb;
                if(aCell === "cell4") self.cell4 = record[0].carNb;
                if(aCell === "cell5") self.cell5 = record[0].carNb;
                if(aCell === "cell6") self.cell6 = record[0].carNb;
                if(aCell === "cell7") self.cell7 = record[0].carNb;
                if(aCell === "cell8") self.cell8 = record[0].carNb;
                if(aCell === "cell9") self.cell9 = record[0].carNb;
                g_gameCardHasData = true;
          }         
       $.ui.hideModal('#gamecard_drivers');
           
        });   
    },
    findCarNb:function(carNb, aCell){
        self = this;
       for(var i=0; i< self.dbDriversArray.length; i++)
       {
           var aDriver = self.dbDriversArray[i];
           if(aDriver.carNb === carNb)
           {
              if(aCell ===  "cell1")
              {
                self.data[0]._class="cell1-1";
                self.data[0]._driver= aDriver.name;
              }
              if(aCell ===  "cell2")
              {
                self.data[1]._class="cell2-1";
                self.data[1]._driver= aDriver.name;
              }
              if(aCell ===  "cell3")
              {
                self.data[2]._class="cell3-1";
                self.data[2]._driver= aDriver.name;
              }
              if(aCell ===  "cell4")
              {
                self.data[3]._class="cell4-1";
                self.data[3]._driver= aDriver.name;
              }
              if(aCell ===  "cell5")
              {
                self.data[4]._class="cell5-1";
                self.data[4]._driver= aDriver.name;
              }
              if(aCell ===  "cell6")
              {
                self.data[5]._class="cell6-1";
                self.data[5]._driver= aDriver.name;
              }
              if(aCell ===  "cell7")
              {
                self.data[6]._class="cell7-1";
                self.data[6]._driver= aDriver.name;
              }
              if(aCell ===  "cell8")
              {
                self.data[7]._class="cell8-1";
                self.data[7]._driver= aDriver.name;
              }
              if(aCell ===  "cell9")
              {
                self.data[8]._class="cell9-1";
                self.data[8]._driver= aDriver.name;
              }
               break;
           }
       }
    },
}