var self;
var prizesFeed = [];
var Prize = {
    id:0,
    eventId : 0,
    description : null,
    type:1,
    prize_image : null,
    sponsor_logo : null,
    sponsor_link : null,
    endOfRace : 0,
    
    
   init:function(_eventId){
       self = this;
       self.getPrizesForEvent(_eventId);  
   },
    getPrizesForEvent: function(_eventId){
        self = this;
        var url = baseURL + getPrizesURL + token + "?v=" + apiVersion; 
         
        var data = {eventId:_eventId};
        $.ajax({
            url:url,
            type:'POST',
            data:data,
             beforeSend:function(){intel.xdk.notification.showBusyIndicator();  $.ui.showMask("Loading...");},
            success:function(result){
               
                intel.xdk.notification.hideBusyIndicator();
                var response = $.parseJSON(result);
                var prizes = response.prizes;
               	 console.log("Prizes: " + JSON.stringify(prizes)); 
                if(response.code == 200)
                {
                    var size = prizes.length;
                   var type;
                    if(size == 9)
                   {
                       // Event does not have Mid Race Prizes
                       type = 9;
                       
                   }
                   else if (size == 18)
                   {
                       // Event has Mid Race Prizes
                       type = 0;
                       
                   }
                    $("#event_prizessub").html("");
                   var prizesTpl = $("#tplPrizesList").html();
                   var prizesList = $("#event_prizessub");
                   
                   for (var i=0; i< size; i++)
                   {
                       var aPrize = prizes[i];
                       var image = imagesBaseURL + _eventId + "/" + aPrize.prize_image;
                       //console.log("imageURL" + image);
                       var patternImage = "";
                       if(type == 0 || type == 9)
                       {
                            patternImage = "img/123.png"
                       }
                       if(type == 1 || type == 10)
                       {
                            patternImage = "img/415.png"
                       }
                       if(type == 2 || type == 11)
                       {
                            patternImage = "img/275.png"
                       }
                       if(type == 3 || type == 12)
                       {
                            patternImage = "img/619.png"
                       }
                       if(type == 4 || type == 13)
                       {
                            patternImage = "img/483.png"
                       }
                       if(type == 5 || type == 14)
                       {
                            patternImage = "img/264.png"
                       }
                       if(type == 6 || type == 15)
                       {
                            patternImage = "img/718.png"
                       }
                       if(type == 7 || type == 16)
                       {
                            patternImage = "img/593.png"
                       }
                       if(type == 8 || type == 17)
                       {
                           patternImage = "img/total.png"
                       }
                       prizesList.append(prizesTpl.format(prizesArray[type],aPrize.id,image, aPrize.description, patternImage));
                       type++;
                       var params = {id:aPrize.id,eventId:_eventId, description:aPrize.description, prize_image:aPrize.prize_image, sponsor_logo:aPrize.sponsor_logo, sponsor_link:aPrize.sponsor_link};
                       
                       prizesFeed.push(params);
                   }
                    
                }
                else{
                    var message = "HTTP CODE : " + response.code + "\n" + response.message;
                     intel.xdk.notification.alert(message,"Prizes List","OK");
                }
                $.ui.hideMask();
            
             intel.xdk.notification.hideBusyIndicator();
            }
        });
        
    },
    getPrize:function(prizeId){
        self = this;
        var url = baseURL + getPrizeURL + token + "?v=" + apiVersion; 
        //console.log("prizes url :", url);
        var data = {prizeId:id};
        $.ajax({
            url:url,
            type:'POST',
            data:data,
            beforeSend:function(){intel.xdk.notification.showBusyIndicator();},
            success:function(result){
                //console.log("Prize Info : "+result);
                intel.xdk.notification.hideBusyIndicator();
                var response = $.parseJSON(result);
               
                if(response.code == 200)
                {
          
                    
                }
                else{
                    var message = "HTTP CODE : " + response.code + "\n" + response.message;
                     intel.xdk.notification.alert(message,"Prizes List","OK");
                }
            }
        });
    },
    getPrizeInfo:function(prizeId)
    {
        self = this;
       
        
        for(var i=0; i< prizesFeed.length; i++)
        {
            var obj = prizesFeed[i];
            if(obj.id == prizeId)
            {
              
                var imageLink = imagesBaseURL + obj.eventId + "/" + obj.prize_image;
               var sponsorLogoLink = imagesBaseURL + obj.eventId + "/" + obj.sponsor_logo;
                var sponsorLink = imagesBaseURL + obj.eventId + "/" + obj.sponsor_link;
                $("#prize_image").attr("src", imageLink); 
                $("#prize_sponsor_logo").attr("src", imageLink); 
                $("#prize_description").html(obj.description);
            }
        }
        
        
    },
    
    
    
};