var user ={
    token:null,
    username:null,
    password:null,
    email:null,
    userId:null,
    userExists: false,
    init:function(){ 
        console.log("Init Called");
        this.getUser();                       
    },
    saveUser:function(){
        var me = this;
        var data = [
                  {
                      name: "userId",
                      value: me.userId
                  },
                  {
                      name: "email",
                      value: me.email
                  },
                  {
                      name: "username",
                      value: me.username
                  },
                  {
                      name: "password",
                      value: me.password
                  }
                  
              ];
        LuckyLapsDB.writeRecord("user",null,data, function(e){
            console.log("e.code : " + e.code);
            //console.log("e.message : " + e.message);
        });
        },
    getUser:function(){
         console.log("GetUser Called");
        var sql = ('SELECT id,email,username,password from user');
        LuckyLapsDB.runQuery(sql,function(record){
           var me = this; 
            if(record[0].length > 0 )
            {
               me.id = record[0].id;
               me.email = record[0].email;
               me.username = record[0].username;
               me.password = record[0].password;
               me.userExists = true;
            }
            
        });
        
    },
    
    print:function(){
        var me = this;
        console.log("userId : " + me.userId + " | Email : " + me.email + " | username : " + me.username + " | password : " + me.password);   
    },
    postUser:function(data){  
        var me = this;
        var url = baseURL + addUserURL + "?v=" + apiVersion; 
         console.log("url :", url);
        $.ajax({
            url:url,
            type:'POST',
            data:data,
            success:function(result){	
                var response = $.parseJSON(result);
                console.log("Response :", response);
                 console.log("code :", response.code);
                 console.log("Q :", response.q);
                 console.log("Message :", response.message);
                 console.log("userId :", response.userId);
                if(response.code == 200 || response.code == 201)
                {
                    //alert(response.message);
                    var message = "HTTP CODE : " + response.code + "\n" + response.message;
                     intel.xdk.notification.alert(message,"Create Account","OK");
                    me.userId = response.userId;
                    me.email = data['email'];
                    me.username = data['username'];
                    me.password = data['password'];
                    me.print();
                    me.saveUser();
                }
                else
                {
                   /* $.ui.popup( {
                            title:"Alert! Alert!",
                            message:response.message,
                            cancelText:false,
                            cancelCallback: false,
                            doneText:"OK",
                            doneCallback: false,
                            cancelOnly:true
                            });*/
                    var message = "HTTP CODE : " + response.code + "\n" + response.message;
                     intel.xdk.notification.alert(message,"Create Account","OK");
                }
            }
        });
    },
    authenticateUser:function(){

        var me = this;
        var myurl = baseURL + authenticateUserURL + "?v=" + apiVersion; 
         console.log("url :", url);
        me.getUser();
        var data = {
                    email: me.email,
                    username: me.username,
                    password: me.password,
                    userId: me.userId,
                    };
        $.ajax({
            url:myurl,
            type:'POST',
            data:data,
            success:function(result){	
                var response = $.parseJSON(result);
                // console.log("code :", response.code);
                // console.log("Token :", response.token);
                if(response.code == 200)
                {
                    me.token = response.token;
                    console.log("token" + me.token);
                    var message = "HTTP CODE : " + response.code + "\n" + response.message;
                     intel.xdk.notification.alert(message,"Authenticate User","OK");
                }
                else
                {
                    var message = "HTTP CODE : " + response.code + "\n" + response.message;
                     intel.xdk.notification.alert(message,"Authenticate User","OK");
                }
            }
        });
        
    
        
    },
    
    
    
}

