/* 
|***************************************************|
|                                                   |
|                   Defining Globals                |
|                                                   |
|***************************************************|
*/
    /* 
    |***************************************************|
    |                       LIVE                        |
    |***************************************************|
    */
    var baseURL = "http://ios.watchmewin.com/api/";
    var imagesBaseURL = "http://ios.watchmewin.com/wmw_admin/assets/files/prizes/";

    /* 
    |***************************************************|
    |                       DEV                         |
    |***************************************************|
    */
//     var baseURL = "http://ios.watchmewin.com/api_dev/";
//     var imagesBaseURL = "http://ios.watchmewin.com/dev/assets/files/prizes/";

    //|***************************************************|
    var apiVersion = "1.0.0";
    var updatesURL = "updates/get/";
    var addUserURL ="users/add/";
    var authenticateUserURL ="users/authenticate/";
    var token = null;
    var getEventURL = "events/get/";
    var getDriversURL = "drivers/get/";
    var postGamecardURL = "gamecards/post/";
    var getGamecardURL = "gamecards/get/";
    var getScoresURL = "results/get/";
    var getLapNbsForEventURL = "results/getLapsForEvent/";
    var getScoresForLap = "results/getScoresForLap/";
    var getBestScoresForLap = "results/getBestScoresForLap/";
    var getScoresForLapForUser = "results/getScoresForLapForUser/";
    var getWinners = "results/getWinners/";
    var postLocation = "geoLocation/add/";
    var postBgLocation = "geoLocation/addBgLocation/";
    var postResetPassword = "users/resetPassword/"
    var addFbUserURL = "users/addFbUser"
    var authenticateFbUserURL = "users/authenticateFbUser"

    var tracksArray = {
                        Chicago_Speedway                :   "img/Chicago_Speedway.png",
                        Darlington_Raceway              :   "img/Darligton_Raceway.png",
                        Daytona_International_Speedway  :   "img/Daytona_International_Speedway.png",
                        Homestead_Miami_Speedway        :   "img/Homestead_Miami_Speedway.png",
                        Indianapolis_Motor_Speedway     :   "img/Indianapolis_Motor_Speedway.png",
                        Kansas_Speedway                 :   "img/Kansas_Speedway.png",
                        Kentucky_Speedway                :   "img/Kentucky_Speedway.png",
                        Las_Vegas_Motor_Speedway        :   "img/Las_Vegas_Motor_Speedway.png",
                        Martinsville_Speedway           :   "img/Martinsville_Speedway.png",
                        Michigan_International_Speedway :   "img/Michigan_International_Speedway.png",
                        New_Hampshire_Motor_Speedway    :   "img/New_Hampshire_Motor_Speedway.png",
                        Sonoma_Raceway                  :   "img/Sonoma_Raceway.png",
                        Talladega_Superspeedway         :   "img/Talladega_Superspeedway",
                        Texas_Motor_Speedway            :   "img/Texas_Motor_Speedway.png",
                        Watkins_Glen_International      :   "img/Watkins_Glen_International.png",
                        Charlotte_Motor_Speedway        :   "img/Charlotte_Motor_Speedway.png",
                        Dover_International_Speedway    :   "img/Dover_International_Speedway.png",
                        Phoenix_International_Raceway   :   "img/Phoenix_International_Raceway.png",
                        Atlanta_Motor_Speedway          :   "img/Atlanta_Motor_Speedway.png",
                        Auto_Club_Speedway              :   "img/Auto_Club_Speedway.png",
                        Bristol_Motor_Speedway          :   "img/Bristol_Motor_Speedway.png",
                        Chicagoland_Speedway            :   "img/Chicagoland_Speedway.png",
                        Pocono_Raceway                  :   "img/Pocono_Raceway.png",
                        Richmond_International_Raceway  :   "img/Richmond_International_Raceway.png",
                        
                        
                        
                };

    var getPrizesURL =  "prizes/get/";
    //var getPrizeURL =  "prizes/getBy/";
    var prizesArray = ["Prize for Pattern 1-2-3 (Mid Race)","Prize for Pattern 4-1-5 (Mid Race)", "Prize for Pattern 2-7-5 (Mid Race)","Prize for Pattern 6-1-9 (Mid Race)","Prize for Pattern 4-8-3 (Mid Race)","Prize for Pattern 2-6-4 (Mid Race)","Prize for Pattern 7-1-8 (Mid Race)", "Prize for Pattern 5-9-3 (Mid Race)", "Prize for Pattern Total (Mid Race)" ,"Prize for Pattern 1-2-3 (End Of Race)","Prize for Pattern 4-1-5 (End Of Race)","Prize for Pattern 2-7-5 (End Of Race)","Prize for Pattern 6-1-9 (End Of Race)","Prize for Pattern 4-8-3 (End Of Race)","Prize for Pattern 2-6-4 (End Of Race)","Prize for Pattern 7-1-8 (End Of Race)","Prize for Pattern 5-9-3 (End Of Race)","Prize for Pattern Total (End Of Race)"];
    var debugData = $("#debug1");
    var g_EventId = 0;
    var g_EventName ="";
    var g_EventStatus = 0;
    var g_isCell1 = false;
    var g_hasMidRaceResults = false;
    var g_isCell2 = false;
    var g_isCell3 = false;
    var g_isCell4 = false;
    var g_isCell5 = false;
    var g_isCell6 = false;
    var g_isCell7 = false;
    var g_isCell8 = false;
    var g_isCell9 = false;
    var g_gameCardHasData = false;   
    var g_userId = 0;
    var g_username = "";
    var g_email = "";
    var g_password = "";
    var g_isFBUser  = false;
    var g_fbUserId = "";
    var g_currentLapNb = 0;
    var g_lastLapNb = 0;
    var g_lapNbsLoaded = false;
    var g_SearchedUsername = "";
    var g_myResults = [];
    var g_hisResults =[];
    var geoTimer;
    var g_distanceFilter = 20.0;
    var g_timeFilter = 120000;
    var prizeListLoaded = false;
    var g_userHasGameCard = false;
    var g_SelectedEventName = "";
    var g_SelectedEventStatus = 0;
    var g_UserHasScores = false;
    var _fb_user;