var self;
function fbUser (params){
    self = this;
    if(params === null){     
        this.userId = 0;
        this.fbUserId = "";
        this.firstname = "";
        this.lastname = "";
        this.email = "";
        this.gender = "";
        this.username = "";
        this.fbUserExists = false;
        this.save = saveUser;
    }
    else{
        
        this.userId = 0;
        this.fbUserId = params.fbUserId;
        this.firstname = params.firstname;
        this.lastname = params.lastname;
        this.email = params.email;
        this.gender = params.gender;
        this.username = params.username;
        this.fbUserExists = true;

    }
};

saveUser = function(self){
	alert("## save user called ##");
    var data = [
              {
                  name: "userId",
                  value: self.getUserId()
              },
              {
                  name: "fbUserId",
                  value: this.getFbUserId()
              },
              {
                  name: "email",
                  value: this.getEmail()
              },
              {
                  name: "username",
                  value: this.getUsername()
              },
              {
                  name: "lastname",
                  value: this.getLastName()
              },
              {
                  name: "firstname",
                  value: this.getFirstName()
              },
              {
                  name: "gender",
                  value: this.getGender()
              } 
          ];          
          alert("## Saving User Record Now ##");
     	  LuckyLapsDB.writeRecord("fbUser",null,data,null, function(e){
            console.log("e.code : " + e.code);
            //var message = "HTTP CODE : " + e.code + "\n There was an error saving user Info";
            	alert("## account saved !!!! ##");
                activate_subpage("#mainsub"); 
                $("#_page_title").html("LuckyLaps"); 
        	});
};
/* Setters */
fbUser.prototype.set = function(params){
    self.userId = 0;
    self.fbUserId = params.fbUserId;
    self.firstname = params.firstname;
    self.lastname = params.lastname;
    self.email = params.email;
    self.gender = params.gender;
    self.username = params.username;
    self.fbUserExists = true;
};
fbUser.prototype.setUsername = function(aUsername){
    self.username = aUsername;
};
fbUser.prototype.setUserId = function(id){
    self.userId = id;
};

/*Getters */
fbUser.prototype.getUsername = function(){
    return self.username;
};
fbUser.prototype.getUserId = function(){
    return self.userId;
};
fbUser.prototype.getLastName = function(){
    return self.lastname;
};
fbUser.prototype.getFirstName = function(){
    return self.firstname;
};
fbUser.prototype.getEmail = function(){
    return self.email;
};
fbUser.prototype.getGender = function(){
    return self.gender;
};
fbUser.prototype.getFbUserId = function(){
    return self.fbUserId;
};
fbUser.prototype.get = function(callback){
	var sql = ('SELECT userId, email, username, fbUserId, gender, firstname, lastname from fbUser');
    LuckyLapsDB.runQuery(sql,function(record){      
		if(record.length == 1){
		alert("FB User Found on db");
		  self.userId = record[0].userId;
		  self.fbUserId = record[0].fbuserId;
		  self.email = record[0].email;
		  self.username = record[0].username;
		  self.lastname = record[0].lastname;
		  self.firstname = record[0].firstname;
		  self.gender = record[0].gender;
		  self.fbUserExists = true;
		  g_userId = self.userId;
		  g_username = self.username;
		  g_fbUserId = self.fbUserId;
		  g_isFBUser = true;
		  alert("userId : " + self.userId +" | fbID : " + self.fbUserId + " | Email : " + self.email + " | username : " + self.username + " | firstname : " + self.firstname + " | lastname : " + self.lastname + " | Gender : " + self.gender);      

		  if(callback) callback();
		}
		else{
		  alert("NO FB User Found on db");
		  callback();
		}
    });   
};

fbUser.prototype.create = function(){
	alert("## save called ##");
    var data = [
              {
                  name: "userId",
                  value: self.userId
              },
              {
                  name: "fbUserId",
                  value: self.fbUserId
              },
              {
                  name: "email",
                  value: self.email
              },
              {
                  name: "username",
                  value: self.username
              },
              {
                  name: "lastname",
                  value: self.lastname
              },
              {
                  name: "firstname",
                  value: self.firstname
              },
              {
                  name: "gender",
                  value: self.gender
              } 
          ];
          alert("## Saving Record Now ##");
     	  LuckyLapsDB.writeRecord("fbUser",null,data,null, function(e){
            console.log("e.code : " + e.code);
            //var message = "HTTP CODE : " + e.code + "\n There was an error saving user Info";
            	alert("## account saved ##");
                    	 activate_subpage("#mainsub"); 
                    	$("#_page_title").html("LuckyLaps"); 
        	});
        
     
};

fbUser.prototype.update = function(params){
     LuckyLapsDB.writeRecord("fbUser",self.fbUserId,params," where fbUserId = ? ", function(e){
            console.log("e.code : " + e.code);
            //var message = "HTTP CODE : " + e.code + "\n There was an error saving user Info";
            //intel.xdk.notification.alert(message,"Create Account","OK");
        });
};

fbUser.prototype.post = function(){
	var url = baseURL + addFbUserURL + "?v=" + apiVersion;
    var data ={
	   			fbId 		: self.fbUserId,
    			username 	: self.username,
    			email 		: self.email,
    			firstname 	: self.firstname,
    			lastname 	: self.lastname,
    			gender		: self.gender
    };
    $.ajax({
        url:url,
        type:'POST',
        data:data,
        success:function(result){
           // console.log("POST Response : "+ result);
            var response = $.parseJSON(result);
            if(response.code == 200 || response.code == 201)
            {
                intel.xdk.notification.alert(response.message,"Create Account","OK");
                self.userId =  response.userId;
                g_userId = self.userId;
                g_fbUserId = self.fbUserId;
                g_username = self.username;
                g_email = self.email;
                g_password = self.password;
                token = response.token;
                alert("calling save");
                saveUser.call(this);
                // alert("calling self test");
//                 self.test;
//                 alert("calling this test");
//                 this.test;
        
                // if(callback) ;
//                 activate_subpage("#mainsub"); 
//                 $("#_page_title").html("LuckyLaps");          
            }
            else
            {
                $.ui.hideMask();
                $.ui.unblockUI();
                intel.xdk.notification.hideBusyIndicator();
                var message = "HTTP CODE : " + response.code + "\n" + response.message;
                intel.xdk.notification.alert(response.message,"Create Account","OK");
            }
        },
         error: function (request, status, error) {
              var req = $.parseJSON(request);
            console.log("### POST Error Response Text : " + request + "<br/>");
            console.log("POST Error Response Text : " + req + "<br/>");
            console.log("POST Error Response Text : " + req.responseText + "<br/>");
            console.log("POST Error Response Status : " + req.status + "<br/>");
            console.log("POST Error status : " + status + "<br/>");
            console.log("POST Error : " + error + "<br/>");
             
        }
    });
};

fbUser.prototype.authenticate = function(callback,anEvent){

alert("Authenticating Now");
	var url = baseURL + authenticateFbUserURL + "?v=" + apiVersion;
    var data ={
	   			fbId 		: self.fbUserId,
    			userId		: self.userId,
    };
    $.ajax({
        url:url,
        type:'POST',
        data:data,
        beforeSend:function(){ alert("POST Athuenticate Data " + JSON.stringify(data));intel.xdk.notification.showBusyIndicator();  $.ui.showMask("Loading...");},
        success:function(result){
           // console.log("POST Response : "+ result);
            var response = $.parseJSON(result);
            if(response.code == 200)
            {
                 self.token = response.token;
                 token = self.token;
                 if(callback && anEvent) processEvent(anEvent,self);
				   else{
						var myEvent = Object.create(Event);
						myEvent.getEventLocalCallback(processEvent(myEvent,self));
					}         
            }
            else
            {
                $.ui.hideMask();
                $.ui.unblockUI();
                intel.xdk.notification.hideBusyIndicator();
                var message = "CODE : " + response.code + "\n" + response.message;
                intel.xdk.notification.alert(response.message,"Create Account","OK");
            }
        },
         error: function (request, status, error) {
              var req = $.parseJSON(request);
            console.log("### POST Error Response Text : " + request + "<br/>");
            console.log("POST Error Response Text : " + req + "<br/>");
            console.log("POST Error Response Text : " + req.responseText + "<br/>");
            console.log("POST Error Response Status : " + req.status + "<br/>");
            console.log("POST Error status : " + status + "<br/>");
            console.log("POST Error : " + error + "<br/>");
             
        }
    });
};

 fbUser.prototype.print = function(){
 	
      alert("userId : " + self.userId +" | fbID : " + self.fbUserId + " | Email : " + self.email + " | username : " + self.username + " | firstname : " + self.firstname + " | lastname : " + self.lastname + " | Gender : " + self.gender);      
};


fbUser.prototype.test = function(){
	alert("test Called");
};




